﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;


namespace Survive
{
    class Camera
    {
        private Vector2 pos;
        private int spd;
        private float tolerance;

        public Camera(Vector2 position, int speed)
        {
            pos = position;
            spd = speed;
            tolerance = 0.3f;
        }

        public void Update(GamePadState gpState)
        {
            if (gpState.ThumbSticks.Left.X > tolerance || gpState.ThumbSticks.Left.X < -tolerance ||
             gpState.ThumbSticks.Left.Y > tolerance || gpState.ThumbSticks.Left.Y < -tolerance)
            {
                gpState.ThumbSticks.Left.Normalize();
                pos.X += (gpState.ThumbSticks.Left.X * spd);
                pos.Y -= (gpState.ThumbSticks.Left.Y * spd);
            }
        }

        public Vector2 Position
        {
            get { return pos;}
        }


    }
}
