﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Audio;

namespace Survive
{
    class Zombie : Sprite
    {
        // vitals
        int health;
        int speed = 1;

        // aiming
        float rotationSpeed;
        float rotationTarget;
        float elapsed;
        float circle;
        float difference;

        Vector2 direction = new Vector2(0, -1);

        public int Health
        {
            get { return health; }
            set { health = value; }
        }

        public Vector2 Direction
        {
            get { return direction; }
            set { direction = value; }
        }

        public Vector2 Position
        {
            get { return position; }
            set { position = value; }
        }

        public Zombie(Texture2D texture, Vector2 position, Point frameSize, Point currentFrame, Point sheetSize, Color color, float scale, float rotation, Vector2 origin, float layerDepth, SpriteEffects spriteEffects, Vector2 collisionOffset, int msPerFrame/*, SoundBank soundBank*/)
            : base(texture, position, frameSize, currentFrame, sheetSize, color, scale, rotation, origin, layerDepth, spriteEffects, collisionOffset, msPerFrame /*, soundBank*/)
        {
            rotationSpeed = (float)MathHelper.Pi;
            circle = MathHelper.TwoPi;
        }

        public override void Update(GameTime gameTime, Rectangle clientBounds)
        {
           // rotate towards player
                elapsed = (float)gameTime.ElapsedGameTime.TotalSeconds;
                direction.Normalize();

                rotationTarget = (float)Math.Atan2(direction.Y, direction.X) - MathHelper.PiOver2;
                difference = MathHelper.WrapAngle(rotation - rotationTarget);

                // clockwise rotation
                if (difference < -0.1f)
                    rotation += (elapsed * rotationSpeed) % circle;

                // counter-clockwise rotation
                if (difference > 0.1f)
                    rotation -= (elapsed * rotationSpeed) % circle;

                rotation = MathHelper.WrapAngle(rotation);
            
            // move towards player
                position += direction * speed;

            base.Update(gameTime, clientBounds);
        }

        public void Draw(SpriteBatch spriteBatch, Vector2 cameraPosition)
        {
            spriteBatch.Draw(texture, new Rectangle((int)(position.X - cameraPosition.X), (int)(position.Y - cameraPosition.Y), 100, 100), new Rectangle(0, 0, 100, 100), color, rotation, origin, spriteEffects, 1.0f);
        }
    }
}
